package com.malk.aiwei.controller;

import com.malk.controller.TBCallBackController;
import com.malk.utils.UtilEnv;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * TB事件回调 3_1
 * -
 * [子项目直接继承即可有调用, 无需实现]
 * -
 * 注解 @RequestMapping 路径不能重复 [主子项目属同一个项目];
 * 获取项目回调请求地址, https://mc.cloudpure.cn/frp/xxx/tb/callback [调试代理: frp + nginx]
 */
@Slf4j
@RestController
@RequestMapping("/tb")
public class TBController extends TBCallBackController {

    // monitor接口ip
    String _getEnvApi(String path) {
        if (UtilEnv.getActiveProfile().equals(UtilEnv.ENV_PROD)) {
            return "http://172.16.20.13:10002/api/public" + path;
        }
        return "http://116.228.113.106:10001/api/public" + path;
    }
}
