package com.malk.aiwei.controller;

/**
 * 错误抛出与拦截详见 CatchException
 */

import com.alibaba.fastjson.JSON;
import com.malk.aiwei.service.AWClint;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.server.common.McR;
import com.malk.server.dingtalk.DDConf;
import com.malk.server.teambition.TBConf;
import com.malk.service.aliwork.YDClient;
import com.malk.service.teambition.TBClient;
import com.malk.service.teambition.TBService;
import com.malk.utils.UtilMap;
import com.malk.utils.UtilServlet;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

@Slf4j
@RestController
@RequestMapping
public class TBxYDController {

    /**
     * 交付物审批回调
     */
    @PostMapping("approved")
    McR approve(HttpServletRequest request) {
        
        Map<String, ?> data = UtilServlet.getParamMap(request);
        log.info("交付物审批回调, {}", data);
//        String workStatusId = "通过".equals(data.get("approve")) ? "65966fb2f33db90815434eb1" : "65966fb2f33db90815434eab";
        String workStatusId = "通过".equals(data.get("approve")) ? "65967ad70e25b16b2e91e56b" : "659679ec3bf0fb46b4b68c9f";
        tbClient.updateTaskFlowStatus(String.valueOf(data.get("taskId")), String.valueOf(data.get("creatorId")), workStatusId, String.valueOf(data.get("approve")));
        return McR.success();
    }

    /**
     * 检查项check回调
     */
    @PostMapping("checked")
    McR check(HttpServletRequest request) {

        Map<String, ?> data = UtilServlet.getParamMap(request);
        log.info("检查项check回调, {}", data);
        String result = UtilMap.getString(data, "approve");
        Map body = TBConf.assembleCustomFieldName("checklist状态", result); // 撤销, 终止, 已检查
        tbClient.updateTaskCustomField(String.valueOf(data.get("taskId")), String.valueOf(data.get("creatorId")), body);
        return McR.success();
    }


    @Autowired
    private TBClient tbClient;

    @Autowired
    private TBService tbService;

    @Autowired
    private TBConf tbConf;

    @Autowired
    private DDConf ddConf;

    @Autowired
    private YDClient ydClient;


    @GetMapping("t/task")
    McR tb(String taskId) {

        log.info("taskId, {}", taskId);
        List<Map> taskList = tbClient.queryTaskDetail(taskId, "", "");
        return McR.success(taskList);
    }

    @GetMapping("y/project")
    McR yd(String taskId) {

        List<Map> dataList = (List<Map>) ydClient.queryData(YDParam.builder()
                .formUuid("FORM-3C7396A12ADB48A8833EBD90089C93833R21")
                .build(), YDConf.FORM_QUERY.retrieve_search_form).getData();

        return McR.success(dataList);
    }

    @Autowired
    private AWClint awClint;

    @GetMapping("t/approve")
    McR tApprove() {
        List<Map> docs = (List<Map>) JSON.parse("[{\"downloadUrl\":\"https://alidocs.dingtalk.com/i/team/o5WXMMM6PLYkJXwO/docs/5WXMN1dEajMJ6mwO?utm_source=tb&utm_medium=tb_task_attach\",\"name\":\"部署信息.docx\"}]");
        awClint.approve("C0001", "65964fe5ae6f3b884c04e332", docs, "659df9e94aa556a15b8cc7ee", "65682c174655a82b4fa04dfe", "0249EDD1-754E-44C8-87F0-255B0E32021F");
        return McR.success();
    }

    @GetMapping("t/checklist")
    McR tChecklist() {
        awClint.check("C0001", "65964fe5ae6f3b884c04e332", null, null, null);
        return McR.success();
    }

    @GetMapping("test")
    McR test() {

        tbClient.idMapQuery(tbConf.getOperatorId(), "dingTalk-user", ddConf.getCorpId());
        return McR.success();
    }

}
